<template>
  <div v-loading="loading">
    <div class="white-box">
      <el-tabs v-model="filterStatus" @tab-click="handleFilterStatusClick">
        <el-tab-pane label="全部" name="-1" :lazy="true"></el-tab-pane>
        <el-tab-pane label="待审核" name="0" :lazy="true"></el-tab-pane>
        <el-tab-pane label="审核通过" name="1" :lazy="true"></el-tab-pane>
        <el-tab-pane label="审核拒绝" name="3" :lazy="true"></el-tab-pane>
      </el-tabs>
      <div class="filter-box">
        <filter-user ref="filterUser" :filter-types="filterTypes" @select-value="handleFilterUser"></filter-user>
      </div>
      <el-table :data="tableData" stripe style="width: 100%;" @selection-change="handleSelectionChange"
                :height="tool.getTableHeight(true)">
        <el-table-column type="selection" width="55" v-if="tableHeaders"></el-table-column>
        <el-table-column v-for="(tableHeader, key) in tableHeaders" :key="key" :label="tableHeader.header" :width="tableHeader.other.width ? tableHeader.other.width : ''">
          <template slot-scope="scope">
            <template v-if="scope.row[tableHeader.index].other.tag" >
              <el-tag :type="scope.row[tableHeader.index].other.tag.type ? scope.row[tableHeader.index].other.tag.type : null" :size="scope.row[tableHeader.index].other.tag.size ? scope.row[tableHeader.index].other.tag.size : null" :class="scope.row[tableHeader.index].other.tag.class ? scope.row[tableHeader.index].other.tag.class : null" >{{scope.row[tableHeader.index].value}}</el-tag>
            </template>
            <template v-else-if="scope.row[tableHeader.index].other.progress" >
              <el-progress type="circle" :percentage="Number.parseInt(percentList['MOVE_PERCENT'][scope.row.ID])"
                           :width="50"
                           :stroke-width="3"></el-progress>
            </template>
            <template v-else>
              <div v-html="scope.row[tableHeader.index].value"></div>
            </template>
          </template>
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="180" v-if="tableHeaders">
          <template slot-scope="scope"
                    v-if="scope.row.AUDIT_STATUS==='0' && (permission.hasPermission(`finance/balance-audit-pass`) || permission.hasPermission(`finance/balance-audit`) || permission.hasPermission(`finance/balance-audit-delete`))">
            <el-dropdown size="small" trigger="click">
              <el-button type="primary" size="small" @click.stop="">
                操作该数据<i class="el-icon-arrow-down el-icon--right"></i>
              </el-button>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="pass" @click.native="handleAuditShow(scope.row)"
                                  v-show="permission.hasPermission(`finance/balance-audit-pass`)">审核通过
                </el-dropdown-item>
                <el-dropdown-item command="refuse" @click.native="handleAudit(scope.row, 'reject')"
                                  v-show="permission.hasPermission(`finance/balance-audit`)">审核拒绝
                </el-dropdown-item>
                <el-dropdown-item command="del" @click.native="handleDel(scope.row.ID)"
                                  v-show="permission.hasPermission(`finance/balance-audit-delete`)">删除数据
                </el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
        </el-table-column>
      </el-table>
      <div class="white-box-footer">
        <el-dropdown size="small" trigger="click" @command="handleMuli"
                     v-if="filterStatus==='0' && (permission.hasPermission(`finance/balance-audit`)||permission.hasPermission(`finance/balance-audit-delete`))">
          <el-button type="primary" size="small">
            所选数据<i class="el-icon-arrow-down el-icon--right"></i>
          </el-button>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command="passMinus" v-if="permission.hasPermission(`finance/balance-audit`)">批量审核允许为负数</el-dropdown-item>
            <el-dropdown-item command="pass" v-if="permission.hasPermission(`finance/balance-audit`)">批量审核不允许为负数</el-dropdown-item>
            <el-dropdown-item command="reject" v-if="permission.hasPermission(`finance/balance-audit`)">批量拒审</el-dropdown-item>
            <el-dropdown-item command="del" @click.native="handleDel()" v-if="permission.hasPermission(`finance/balance-audit-delete`)">批量删除</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <el-button type="primary" size="small" @click="handleAdd" icon="el-icon-plus"
                   v-show="permission.hasPermission(`finance/change-balance-opt`)">申请变动会员余额
        </el-button>
        <el-button type="success" size="small" @click="handleExport"
                   v-show="permission.hasPermission(`finance/balance-audit-list-export`)">导出Excel
        </el-button>
        <pagination :total="totalCount" :page_size="pageSize" @size-change="handleSizeChange" @current-change="handleCurrentChange"></pagination>
      </div>
      <el-dialog title="修改会员余额变动信息" :visible.sync="dialogEditFormVisible">
        <el-form :model="form" label-width="150px" class="form-dialog" v-loading="dialogEditLoading">
          <el-form-item label="会员编号">
            <el-input v-model="form.baseInfo.USER_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="会员姓名">
            <el-input v-model="form.baseInfo.REAL_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="账户类型">
            <el-select v-model="form.type" placeholder="请选择账户类型">
              <el-option v-for="(item,key) in type" :label="item.label" :value="key" :key="key"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="调整金额">
            <el-input v-model="form.amount"></el-input>
          </el-form-item>
          <el-form-item label="交易类型">
            <el-select v-model="form.dealType" placeholder="请选择交易类型">
              <el-option v-for="(item,key) in dealTypes" :label="item.TYPE_NAME" :value="item.ID"
                         :key="item.ID"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="备注">
            <el-input v-model="form.remark"></el-input>
          </el-form-item>
          <el-form-item label="备注前台显示">
            <el-switch v-model="form.isShow" active-value="1" inactive-value="0">
            </el-switch>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogEditFormVisible = false">取 消</el-button>
          <el-button type="primary" @click.native="handleEdit">修 改</el-button>
        </div>
      </el-dialog>
      <el-dialog title="审核会员余额变动信息" :visible.sync="dialogAuditFormVisible">
        <el-form :model="form" label-width="250px" class="form-dialog" v-loading="dialogAuditLoading">
          <el-form-item label="会员编号">
            <el-input v-model="form.baseInfo.USER_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="会员姓名">
            <el-input v-model="form.baseInfo.REAL_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="账户类型">
            <el-select v-model="form.type" placeholder="请选择账户类型">
              <el-option v-for="(item,key) in type" :label="item.label" :value="key" :key="key"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item :label="item.label" v-show="form.baseInfo.REAL_NAME!==null && item.name===form.type"
                        v-for="(item,key) in type" :key="key">
            <el-input :value="form.baseInfo[item.name.toUpperCase()]" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="调整金额">
            <el-input v-model="form.amount"></el-input>
          </el-form-item>
          <el-form-item label="交易类型">
            <el-select v-model="form.dealType" placeholder="请选择交易类型">
              <el-option v-for="(item,key) in dealTypes" :label="item.TYPE_NAME" :value="item.ID"
                         :key="item.ID"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="备注前台显示">
            <el-switch v-model="form.isShow" active-value="1" inactive-value="0">
            </el-switch>
          </el-form-item>
          <el-form-item label="备注">
            <el-input v-model="form.remark"></el-input>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogAuditFormVisible = false">取 消</el-button>
          <el-button type="primary" @click.native="handleAuditPass" :disabled="auditPassButtonStat">通 过</el-button>
        </div>
      </el-dialog>
    </div>
  </div>
</template>

<script>
  import network from '@/utils/network'
  import tool from '@/utils/tool'
  import FilterUser from '@/components/FilterUser'
  import baseInfo from '@/utils/baseInfo'
  import permission from '@/utils/permission'
  import Pagination from '@/components/Pagination'
  import filterHelper from '@/utils/filterHelper'

  export default {
    name: 'leo-balance-audit-table',
    components: {FilterUser,Pagination},
    mounted() {
      network.getData('finance/change-balance-type').then(response => {
        this.type = response.type
        this.dealTypes = response.dealTypes
        this.getData()
      })
    },
    data() {
      return {
        tableHeaders: null,
        tableData: null,
        loading: true,
        multipleSelection: [],
        currentPage: 1,
        totalPages: 1,
        totalCount: 1,
        pageSize: 20,
        tool: tool,
        permission: permission,
        baseDecLevels: baseInfo.decLevels(),
        filterTypes: {},
        filterModel: {},
        filterStatus: '0',
        type: null,
        dealTypes: null,
        dialogEditLoading: false,
        dialogAuditLoading: false,
        dialogEditFormVisible: false,
        dialogAuditFormVisible: false,
        auditPassButtonStat: true,
        auditId: null,
        form: {
          id: null,
          baseInfo: {USER_NAME: null},
          type: null,
          dealType: null,
          amount: 0,
          createRemark: '',
          remark: '',
          auditStatus: null,
          balanceCode:''
        },
      }
    },
    methods: {
      handleMuli(command) {
        if (this.multipleSelection.length < 1) {
          this.$message({
            message: '请选择要操作的记录',
            type: 'warning'
          })
          return;
        }
        if (command === 'pass') {
          this.handleAudit(null, 'true')
        } else if (command === 'reject') {
          this.handleAudit(null, 'reject')
        } else if (command === 'passMinus') {
          this.handleAudit(null, 'true', true)
        }
      },
      handleAdd() {
        this.$router.push({path: `/finance/change-balance-opt`})
      },
      handleEditShow(row) {
        this.dialogEditLoading = true
        this.auditId = row.ID
        this.dialogEditFormVisible = true
        let vueObj = this
        network.getData('finance/balance-audit-get', {id: this.auditId}).then(response => {
          vueObj.dialogEditLoading = false
          vueObj.form = response
          vueObj.form.type = String(response.type)
          vueObj.form.createRemark = vueObj.form.remark
        })
      },
      handleEdit() {
        this.dialogEditFormVisible = false
        this.$message({
          message: '正在修改数据',
          type: 'info'
        })
        let path = 'finance/balance-audit-edit'
        network.postData(path, this.form).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {
        })
      },
      handleAuditShow(row) {
        this.dialogAuditLoading = true
        this.auditId = row.ID
        this.dialogAuditFormVisible = true
        let vueObj = this
        network.getData('finance/balance-audit-get', {id: this.auditId}).then(response => {
          vueObj.dialogAuditLoading = false
          //vueObj.form = response
          vueObj.form.id = response.id
          vueObj.form.baseInfo = response.baseInfo
          vueObj.form.dealType = response.dealType
          vueObj.form.amount = response.amount
          vueObj.form.remark = response.remark
          vueObj.form.auditStatus = response.auditStatus
          vueObj.form.type = String(response.type)
          vueObj.form.createRemark = vueObj.form.remark
        })
        network.postData('finance/mult-point', {opType: 1}).then(response => {
            this.form.balanceCode = response.balanceCode
            this.auditPassButtonStat = false
        })
      },
      handleAuditPass() {
          if (this.form.type === 'bonus') {
            if ((Number.parseFloat(this.form.baseInfo['BONUS']) + Number.parseFloat(this.form.amount)) < 0) {
              this.$confirm(`会员账户余额不足，是否继续提交`, '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
              }).then(() => {
                this._handleAuditPass()
              }).catch(() => {
                this.submitButtonStat = false
                return false
              })
            } else {
              this._handleAuditPass()
            }
          } else {
            this._handleAuditPass()
          }
      },
      _handleAuditPass() {
        this.dialogAuditFormVisible = false
        this.$message({
          message: '正在通过审核',
          type: 'info'
        })
        this.form.auditStatus = 'true'
        let path = 'finance/balance-audit-pass'
        network.postData(path, this.form).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {
        })
      },
      handleAudit(row = null, status, minus = false) {
        let obj = this
        let title = '确定要通过审核（会员账户不允许为负数）？备注：'
        if (status === 'reject') {
          title = '确定要拒绝审核？备注：'
        }else if(minus){
          title = '确定要通过审核（会员账户允许为负数）？备注：'
        }
          network.postData('finance/mult-point', {opType: 1}).then(response => {
              this.form.balanceCode = response.balanceCode
              this.$prompt(title, '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                inputValue: row ? row.REMARK : '',
                //type: 'warning',
              }).then(({value}) => {
                let selectedIds = []
                if (row === null) {
                  for (let val of obj.multipleSelection) {
                    selectedIds.push(val.ID)
                  }
                } else {
                  selectedIds.push(row.ID)
                }
                return network.postData(`finance/balance-audit`, {
                  selected: selectedIds,
                  remark: value,
                  allowMinus: minus,
                  auditStatus: status,
                  balanceCode: this.form.balanceCode
                })
              }).then(response => {
                this.$message({
                  message: response,
                  type: 'success'
                })
                this.getData(this.currentPage, this.pageSize)
              }).catch(response => {

              })
          })
      },
      handleDel(id = null) {
        let obj = this
        this.$confirm('确定删除选定的数据？', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          let selectedIds = []
          if (id === null) {
            for (let val of obj.multipleSelection) {
              selectedIds.push(val.ID)
            }
          } else {
            selectedIds.push(id)
          }
          return network.postData(`finance/balance-audit-delete`, {
            selected: selectedIds
          })
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          obj.getData(obj.currentPage, obj.pageSize)
        }).catch(response => {

        })
      },
      handleSelectionChange(val) {
        this.multipleSelection = val
      },
      handleCurrentChange(page) {
        this.getData(page, this.pageSize)
      },
      handleSizeChange(pageSize) {
        this.getData(this.currentPage, pageSize)
      },
      handleFilterStatusClick(tab, event) {
        filterHelper.clearFilterOption(this)
        this.getData()
      },
      handleFilterUser(filterData) {
        filterHelper.handleFilterUser(this, filterData)
      },
      getData(page, pageSize) {
        let filterData = this.filterModel
        let vueObj=this
        filterData.filterStatus = this.filterStatus != -1 ? `=,${this.filterStatus}` : ''
        network.getPageData(this, 'finance/balance-audit-list', page, pageSize, filterData, function (response) {
          vueObj.allData = response
          vueObj.filterTypes = response.filterTypes
        })
      },
      handleExport(){
        this.$confirm(`确定要导出当前数据吗？`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          return network.getData(`finance/balance-audit-list-export`, this.filterModel)
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
        }).catch(response => {

        })
      },
    }
  }
</script>

<style scoped>

</style>